#include "SenseVidApplication.h"

Define_Module(SenseVidApplication);

void SenseVidApplication::startup(){

  reportDestination = par("reportDestination").stringValue();
  isSink = par("isSink");//can be deduced from sinkAddress
  isSource = par("isSource");
  stFileName = par ("stFileName").stringValue();
  rtFileName = par ("rtFileName").stringValue();
  initTxTime = par ("initTxTime");
  
  if (isSink){
    trace() << "THISISASINK "<<self<<"Receive file is "<<rtFileName<<"\n";
    rtFile.open(rtFileName, ofstream::out);
    if (!stFile){ 
      trace() << "Problem opening output trace file";
      exit(EXIT_FAILURE);
    }

  };

  if (isSource) {
    trace() << "THISISASOURCE "<<self<<"Send file is "<<stFileName<<"\n";

    stFile.open(stFileName,ifstream::in);
    if (!stFile){  
      trace() << "Problem opening input trace file";
      exit(EXIT_FAILURE);
    }
    sendTime1=0;
    setTimer(READ_LINE, initTxTime);
  }

}

void SenseVidApplication::finishSpecific(){
  //trace() << "FINISH ";
  if (isSource) stFile.close();
  if (isSink) rtFile.close();


}

void SenseVidApplication::fromNetworkLayer(ApplicationPacket * rcvPacket,
                        const char *source, double rssi, double lqi){

  //trace () << "RCV DP "<<rcvPacket->getSequenceNumber();
  rtFile << simTime() <<"\t" << rcvPacket->getSequenceNumber()<<"\n";

}


void SenseVidApplication::timerFiredCallback(int timer){

  switch (timer) {
  case READ_LINE:{
    if(getline(stFile,line)){
      if (line[0] != '#' && line[0] != ' ' && !line.empty()){
	stringstream lineStream(line);
	lineStream >> sendTime2 >> seqNb >> payloadSize;
	//trace()<<"Schedule to "<<sendTime2-sendTime1;
	setTimer(SEND_PACKET, sendTime2-sendTime1);
	
      } else setTimer(READ_LINE, 0);
    }
    break;
  }
    
  case SEND_PACKET:{
    ApplicationPacket* pkt =
      createGenericDataPacket(0, seqNb, payloadSize);
    trace() << "Sending packet ..."<< seqNb;
    toNetworkLayer(pkt, reportDestination.c_str());
    sendTime1=sendTime2;
    setTimer(READ_LINE, 0); 
    break;
  }//case
    
  }//switch
}
